Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 2036)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -902,5 +902,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -1211,5 +1211,5 @@
 
 
-          flux_t(k) = w(k,j,i) * (                                            &
+          flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
                      ( 37.0_wp * ibit8 * adv_sca_5                            &
                   +     7.0_wp * ibit7 * adv_sca_3                            &
@@ -1225,5 +1225,5 @@
                                  )
 
-          diss_t(k) = -ABS( w(k,j,i) ) * (                                    &
+          diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
                      ( 10.0_wp * ibit8 * adv_sca_5                            &
                   +     3.0_wp * ibit7 * adv_sca_3                            &
@@ -1266,9 +1266,9 @@
              fd_1   =  ( w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )           &
                    -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )           &
-                       ) * adv_sca_1 
+                       ) * adv_sca_1 * rho_air_zw(k)
 
              ft_1   =  ( w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )             &
                    -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )             &
-                      ) * adv_sca_1 
+                      ) * adv_sca_1 * rho_air_zw(k)
 !
 !--          Calculate ratio of upwind gradients. Note, Min/Max is just to 
@@ -1386,5 +1386,5 @@
                                          + IBITS(wall_flags_0(k,j,i-1),2,1)    &
                                          )                                     &
-                          ) * ddx                                              &
+                          ) * rho_air(k) * ddx                                 &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
                           - v(k,j,i)   * ( IBITS(wall_flags_0(k,j-1,i),3,1)    &
@@ -1392,7 +1392,9 @@
                                          + IBITS(wall_flags_0(k,j-1,i),5,1)    &
                                          )                                     &
-                          ) * ddy                                              &
-                        + ( w(k,j,i)   * ( ibit6 + ibit7 + ibit8 )             &
-                          - w(k-1,j,i) * ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
+                          ) * rho_air(k) * ddy                                 &
+                        + ( w(k,j,i) * rho_air_zw(k) *                         &
+                                         ( ibit6 + ibit7 + ibit8 )             &
+                          - w(k-1,j,i) * rho_air_zw(k-1) *                     &
+                                         ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),7,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),8,1)    &
@@ -1406,6 +1408,7 @@
                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
                           swap_diss_y_local(k,tn)              ) * ddy        &
-                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
-                                                               ) * ddzw(k)    &
+                      + ( ( flux_t(k) + diss_t(k) ) -                         &
+                          ( flux_d    + diss_d    )                           &
+                                                    ) * drho_air(k) * ddzw(k) &
                                       ) + sk(k,j,i) * div
 
@@ -1454,5 +1457,5 @@
           k_mm  = k - 2 * ibit8
 
-          flux_t(k) = w(k,j,i) * (                                            &
+          flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
                     ( 37.0_wp * ibit8 * adv_sca_5                             &
                  +     7.0_wp * ibit7 * adv_sca_3                             &
@@ -1468,5 +1471,5 @@
                                  )
 
-          diss_t(k) = -ABS( w(k,j,i) ) * (                                    &
+          diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
                     ( 10.0_wp * ibit8 * adv_sca_5                             &
                  +     3.0_wp * ibit7 * adv_sca_3                             &
@@ -1511,9 +1514,9 @@
              fd_1   =  ( w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )           &
                    -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )           &
-                       ) * adv_sca_1 
+                       ) * adv_sca_1  * rho_air_zw(k)
 
              ft_1   =  ( w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )             &
                    -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )             &
-                       ) * adv_sca_1 
+                       ) * adv_sca_1  * rho_air_zw(k)
 !
 !--          Calculate ratio of upwind gradients. Note, Min/Max is just to 
@@ -1626,7 +1629,8 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx                   &
-                        + ( v(k,j+1,i) - v(k,j,i)   ) * ddy                   &
-                        + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+          div         =   ( u(k,j,i+1) - u(k,j,i)   ) * rho_air(k) * ddx      &
+                        + ( v(k,j+1,i) - v(k,j,i)   ) * rho_air(k) * ddy      &
+                        + ( w(k,j,i)   * rho_air_zw(k) -                      &
+                            w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)
 
           tend(k,j,i) = tend(k,j,i) - (                                       &
@@ -1635,6 +1639,7 @@
                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
                           swap_diss_y_local(k,tn)              ) * ddy        &
-                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
-                                                               ) * ddzw(k)    &
+                      + ( ( flux_t(k) + diss_t(k) ) -                         &
+                          ( flux_d    + diss_d    )                           &
+                                                    ) * drho_air(k) * ddzw(k) &
                                       ) + sk(k,j,i) * div
 
@@ -1734,5 +1739,6 @@
 
        USE arrays_3d,                                                         &
-           ONLY:  ddzw, diss_l_u, diss_s_u, flux_l_u, flux_s_u, tend, u, v, w
+           ONLY:  ddzw, diss_l_u, diss_s_u, flux_l_u, flux_s_u, tend, u, v, w,&
+                  drho_air, rho_air, rho_air_zw
 
        USE constants,                                                         &
@@ -1999,5 +2005,5 @@
 
           w_comp    = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air_zw(k) * (                              &
                      ( 37.0_wp * ibit17 * adv_mom_5                           &
                   +     7.0_wp * ibit16 * adv_mom_3                           &
@@ -2014,5 +2020,5 @@
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (                     &
                      ( 10.0_wp * ibit17 * adv_mom_5                           &
                   +     3.0_wp * ibit16 * adv_mom_3                           &
@@ -2037,6 +2043,6 @@
                                       + IBITS(wall_flags_0(k,j,i-1),10,1)     &
                                       + IBITS(wall_flags_0(k,j,i-1),11,1)     &
-                                      )                                       &   
-                  ) * ddx                                                     &
+                                      )                                       &
+                  ) * rho_air(k) * ddx                                        &
                +  ( ( v_comp + gv ) * ( ibit12 + ibit13 + ibit14 )            &
                   - ( v(k,j,i)   + v(k,j,i-1 )  )                             &
@@ -2045,7 +2051,7 @@
                                       + IBITS(wall_flags_0(k,j-1,i),14,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-               +  ( w_comp          * ( ibit15 + ibit16 + ibit17 )            &
-                - ( w(k-1,j,i) + w(k-1,j,i-1) )                               &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k) * ( ibit15 + ibit16 + ibit17 )     &
+                - ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)             &
                                     * ( IBITS(wall_flags_0(k-1,j,i),15,1)     &
                                       + IBITS(wall_flags_0(k-1,j,i),16,1)     &
@@ -2061,6 +2067,7 @@
                           + ( flux_n(k) + diss_n(k)                           &
                           -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
-                          + ( flux_t(k) + diss_t(k)                           &
-                          -   flux_d    - diss_d                  ) * ddzw(k) &
+                          + ( ( flux_t(k) + diss_t(k) )                       &
+                          -   ( flux_d    + diss_d )                          &
+                                                    ) * drho_air(k) * ddzw(k) &
                                        ) + div * u(k,j,i)
 
@@ -2127,5 +2134,5 @@
 
           w_comp    = w(k,j,i) + w(k,j,i-1)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air_zw(k) * (                              &
                      ( 37.0_wp * ibit17 * adv_mom_5                           &
                   +     7.0_wp * ibit16 * adv_mom_3                           &
@@ -2142,5 +2149,5 @@
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (                     &
                      ( 10.0_wp * ibit17 * adv_mom_5                           &
                   +     3.0_wp * ibit16 * adv_mom_3                           &
@@ -2161,6 +2168,10 @@
 !--       by a not sufficient reduction of divergences near topography.
           div = ( ( u_comp(k)   - ( u(k,j,i)   + u(k,j,i-1)   ) ) * ddx       &
+                                                                  * rho_air(k)&
                +  ( v_comp + gv - ( v(k,j,i)   + v(k,j,i-1 )  ) ) * ddy       &
-               +  ( w_comp      - ( w(k-1,j,i) + w(k-1,j,i-1) ) ) * ddzw(k)   &
+                                                                  * rho_air(k)&
+               +  (   w_comp                      * rho_air_zw(k)   -         &
+                    ( w(k-1,j,i) + w(k-1,j,i-1) ) * rho_air_zw(k-1)           &
+                  ) * ddzw(k)                                                 &
                 ) * 0.5_wp
 
@@ -2170,6 +2181,7 @@
                           + ( flux_n(k) + diss_n(k)                           &
                           -   flux_s_u(k,tn) - diss_s_u(k,tn)     ) * ddy     &
-                          + ( flux_t(k) + diss_t(k)                           &
-                          -   flux_d    - diss_d                  ) * ddzw(k) &
+                          + ( ( flux_t(k) + diss_t(k) )                       &
+                          -   ( flux_d    + diss_d    )                       &
+                                                    ) * drho_air(k) * ddzw(k) &
                                        ) + div * u(k,j,i)
 
@@ -2219,5 +2231,6 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzw, diss_l_v, diss_s_v, flux_l_v, flux_s_v, tend, u, v, w
+           ONLY:  ddzw, diss_l_v, diss_s_v, flux_l_v, flux_s_v, tend, u, v, w, &
+                  drho_air, rho_air, rho_air_zw
 
        USE constants,                                                          &
@@ -2486,5 +2499,5 @@
 
           w_comp    = w(k,j-1,i) + w(k,j,i)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air_zw(k) * (                              &
                      ( 37.0_wp * ibit26 * adv_mom_5                           &
                   +     7.0_wp * ibit25 * adv_mom_3                           &
@@ -2501,5 +2514,5 @@
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (                     &
                      ( 10.0_wp * ibit26 * adv_mom_5                           &
                   +     3.0_wp * ibit25 * adv_mom_3                           &
@@ -2525,6 +2538,6 @@
                                          + IBITS(wall_flags_0(k,j,i-1),19,1)  &
                                          + IBITS(wall_flags_0(k,j,i-1),20,1)  &
-                                         )                                    &   
-                  ) * ddx                                                     &
+                                         )                                    &
+                  ) * rho_air(k) * ddx                                        &
                +  ( v_comp(k)                                                 &
                                        * ( ibit21 + ibit22 + ibit23 )         &
@@ -2533,9 +2546,8 @@
                                          + IBITS(wall_flags_0(k,j-1,i),22,1)  &
                                          + IBITS(wall_flags_0(k,j-1,i),23,1)  &
-                                         )                                    &   
-                  ) * ddy                                                     &
-               +  ( w_comp                                                    &
-                                       * ( ibit24 + ibit25 + ibit26 )         &
-                - ( w(k-1,j-1,i) + w(k-1,j,i) )                               &
+                                         )                                    &
+                  ) * rho_air(k) * ddy                                        &
+               +  ( w_comp * rho_air_zw(k) * ( ibit24 + ibit25 + ibit26 )     &
+                - ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)             &
                                        * ( IBITS(wall_flags_0(k-1,j,i),24,1)  &
                                          + IBITS(wall_flags_0(k-1,j,i),25,1)  &
@@ -2551,6 +2563,7 @@
                        + ( flux_n(k) + diss_n(k)                              &
                        -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
-                       + ( flux_t(k) + diss_t(k)                              &
-                       -   flux_d    - diss_d                    ) * ddzw(k)  &
+                       + ( ( flux_t(k) + diss_t(k) )                          &
+                       -   ( flux_d    + diss_d    )                          &
+                                                   ) * drho_air(k) * ddzw(k)  &
                                       ) + v(k,j,i) * div
 
@@ -2622,5 +2635,5 @@
 
           w_comp    = w(k,j-1,i) + w(k,j,i)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air_zw(k) * (                              &
                      ( 37.0_wp * ibit26 * adv_mom_5                           &
                   +     7.0_wp * ibit25 * adv_mom_3                           &
@@ -2637,5 +2650,5 @@
                                  )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (                     &
                      ( 10.0_wp * ibit26 * adv_mom_5                           &
                   +     3.0_wp * ibit25 * adv_mom_3                           &
@@ -2656,6 +2669,10 @@
 !--       by a not sufficient reduction of divergences near topography.
           div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx       &
+                                                                  * rho_air(k)&
                +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy       &
-               +  ( w_comp      - ( w(k-1,j-1,i) + w(k-1,j,i) ) ) * ddzw(k)   &
+                                                                  * rho_air(k)&
+               +  (   w_comp                      * rho_air_zw(k)   -         &
+                    ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)           &
+                  ) * ddzw(k)                                                 &
                 ) * 0.5_wp
 
@@ -2665,6 +2682,7 @@
                        + ( flux_n(k) + diss_n(k)                              &
                        -   flux_s_v(k,tn) - diss_s_v(k,tn)       ) * ddy      &
-                       + ( flux_t(k) + diss_t(k)                              &
-                       -   flux_d    - diss_d                    ) * ddzw(k)  &
+                       + ( ( flux_t(k) + diss_t(k) )                          &
+                       -   ( flux_d    + diss_d    )                          &
+                                                   ) * drho_air(k) * ddzw(k)  &
                                       ) + v(k,j,i) * div
 
@@ -2714,5 +2732,6 @@
 
        USE arrays_3d,                                                         &
-           ONLY:  ddzu, diss_l_w, diss_s_w, flux_l_w, flux_s_w, tend, u, v, w
+           ONLY:  ddzu, diss_l_w, diss_s_w, flux_l_w, flux_s_w, tend, u, v, w,&
+                  drho_air_zw, rho_air, rho_air_zw
 
        USE constants,                                                         &
@@ -2984,5 +3003,5 @@
 
           w_comp    = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air(k+1) * (                               &
                      ( 37.0_wp * ibit35 * adv_mom_5                           &
                   +     7.0_wp * ibit34 * adv_mom_3                           &
@@ -2999,5 +3018,5 @@
                                 )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (                      &
                      ( 10.0_wp * ibit35 * adv_mom_5                           &
                   +     3.0_wp * ibit34 * adv_mom_3                           &
@@ -3024,5 +3043,5 @@
                                       + IBITS(wall_flags_0(k,j,i-1),29,1)     &
                                       )                                       &
-                  ) * ddx                                                     &
+                  ) * rho_air_zw(k) * ddx                                     &
               +   ( ( v_comp + gv ) * ( ibit30 + ibit31 + ibit32 )            & 
                   - ( v(k+1,j,i) + v(k,j,i)   )                               &
@@ -3031,7 +3050,7 @@
                                       + IBITS(wall_flags_00(k,j-1,i),0,1)     &
                                       )                                       &
-                  ) * ddy                                                     &
-              +   ( w_comp          * ( ibit33 + ibit34 + ibit35 )            &
-                - ( w(k,j,i)   + w(k-1,j,i)   )                               &
+                  ) * rho_air_zw(k) * ddy                                     &
+              +   ( w_comp * rho_air(k+1) * ( ibit33 + ibit34 + ibit35 )      &
+                - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
                                     * ( IBITS(wall_flags_00(k-1,j,i),1,1)     &
                                       + IBITS(wall_flags_00(k-1,j,i),2,1)     &
@@ -3047,6 +3066,7 @@
                     + ( flux_n(k) + diss_n(k)                                 &
                     -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
-                    + ( flux_t(k) + diss_t(k)                                 &
-                    -   flux_d    - diss_d                    ) * ddzu(k+1)   &
+                    + ( ( flux_t(k) + diss_t(k) )                             &
+                    -   ( flux_d    + diss_d    )                             &
+                                              ) * drho_air_zw(k) * ddzu(k+1)  &
                                       ) + div * w(k,j,i)
 
@@ -3105,5 +3125,5 @@
 
           w_comp    = w(k+1,j,i) + w(k,j,i)
-          flux_t(k) = w_comp  * (                                             &
+          flux_t(k) = w_comp * rho_air(k+1) * (                               &
                      ( 37.0_wp * ibit35 * adv_mom_5                           &
                   +     7.0_wp * ibit34 * adv_mom_3                           &
@@ -3120,5 +3140,5 @@
                                 )
 
-          diss_t(k) = - ABS( w_comp ) * (                                     &
+          diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (                      &
                      ( 10.0_wp * ibit35 * adv_mom_5                           &
                   +     3.0_wp * ibit34 * adv_mom_3                           &
@@ -3139,6 +3159,10 @@
 !--       by a not sufficient reduction of divergences near topography.
           div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx         &
+                                                              * rho_air_zw(k) &
               +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy         &
-              +   ( w_comp      - ( w(k,j,i)   + w(k-1,j,i) ) ) * ddzu(k+1)   &
+                                                              * rho_air_zw(k) &
+              +   (   w_comp                    * rho_air(k+1) -              &
+                    ( w(k,j,i)   + w(k-1,j,i) ) * rho_air(k)                  &
+                  ) * ddzu(k+1)                                               &
                 ) * 0.5_wp
 
@@ -3148,6 +3172,7 @@
                     + ( flux_n(k) + diss_n(k)                                 &
                     -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy         &
-                    + ( flux_t(k) + diss_t(k)                                 &
-                    -   flux_d    - diss_d                    ) * ddzu(k+1)   &
+                    + ( ( flux_t(k) + diss_t(k) )                             &
+                    -   ( flux_d    + diss_d    )                             &
+                                              ) * drho_air_zw(k) * ddzu(k+1)  &
                                       ) + div * w(k,j,i)
 
@@ -3183,5 +3208,5 @@
 
        USE arrays_3d,                                                         &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                         &
@@ -3484,5 +3509,5 @@
 
 
-                flux_t(k) = w(k,j,i) * (                                      &
+                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                      &
                            ( 37.0_wp * ibit8 * adv_sca_5                      &
                         +     7.0_wp * ibit7 * adv_sca_3                      &
@@ -3498,5 +3523,5 @@
                                        )
 
-                diss_t(k) = -ABS( w(k,j,i) ) * (                              &
+                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
                            ( 10.0_wp * ibit8 * adv_sca_5                      &
                         +     3.0_wp * ibit7 * adv_sca_3                      &
@@ -3539,9 +3564,9 @@
                    fd_1   = (  w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )     &
                          -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )     &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 
                    ft_1   = (  w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )       &
                          -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )       &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 !
 !--                Calculate ratio of upwind gradients. Note, Min/Max is just
@@ -3659,5 +3684,5 @@
                                          + IBITS(wall_flags_0(k,j,i-1),2,1)    &
                                          )                                     &
-                          ) * ddx                                              &
+                          ) * rho_air(k) * ddx                                 &
                         + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
                           - v(k,j,i)   * ( IBITS(wall_flags_0(k,j-1,i),3,1)    &
@@ -3665,7 +3690,9 @@
                                          + IBITS(wall_flags_0(k,j-1,i),5,1)    &
                                          )                                     &
-                          ) * ddy                                              &
-                        + ( w(k,j,i)   * ( ibit6 + ibit7 + ibit8 )             &
-                          - w(k-1,j,i) * ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
+                          ) * rho_air(k) * ddy                                 &
+                        + ( w(k,j,i) * rho_air_zw(k) *                         &
+                                         ( ibit6 + ibit7 + ibit8 )             &
+                          - w(k-1,j,i) * rho_air_zw(k-1) *                     &
+                                         ( IBITS(wall_flags_0(k-1,j,i),6,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),7,1)    &
                                          + IBITS(wall_flags_0(k-1,j,i),8,1)    &
@@ -3679,6 +3706,7 @@
                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
                           swap_diss_y_local(k)              ) * ddy           &
-                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
-                                                               ) * ddzw(k)    &
+                      + ( ( flux_t(k) + diss_t(k) ) -                         &
+                          ( flux_d    + diss_d    )                           &
+                                                    ) * drho_air(k) * ddzw(k) &
                                             ) + sk(k,j,i) * div
 
@@ -3725,5 +3753,5 @@
 
 
-                flux_t(k) = w(k,j,i) * (                                      &
+                flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                      &
                            ( 37.0_wp * ibit8 * adv_sca_5                      &
                         +     7.0_wp * ibit7 * adv_sca_3                      &
@@ -3739,5 +3767,5 @@
                                        )
 
-                diss_t(k) = -ABS( w(k,j,i) ) * (                              &
+                diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
                            ( 10.0_wp * ibit8 * adv_sca_5                      &
                         +     3.0_wp * ibit7 * adv_sca_3                      &
@@ -3780,9 +3808,9 @@
                    fd_1   = (  w(k-1,j,i)   * ( sk(k,j,i) + sk(k-1,j,i) )     &
                          -ABS( w(k-1,j,i) ) * ( sk(k,j,i) - sk(k-1,j,i) )     &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 
                    ft_1   = (  w(k,j,i)   * ( sk(k+1,j,i) + sk(k,j,i) )       &
                          -ABS( w(k,j,i) ) * ( sk(k+1,j,i) - sk(k,j,i) )       &
-                            ) * adv_sca_1 
+                            ) * adv_sca_1 * rho_air_zw(k)
 !
 !--                Calculate ratio of upwind gradients. Note, Min/Max is just
@@ -3895,7 +3923,8 @@
 !--             correction is needed to overcome numerical instabilities introduced
 !--             by a not sufficient reduction of divergences near topography.
-                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx             &
-                              + ( v(k,j+1,i) - v(k,j,i)   ) * ddy             &
-                              + ( w(k,j,i)   - w(k-1,j,i) ) * ddzw(k)
+                div         =   ( u(k,j,i+1) - u(k,j,i)   ) * rho_air(k) * ddx &
+                              + ( v(k,j+1,i) - v(k,j,i)   ) * rho_air(k) * ddy &
+                              + ( w(k,j,i)   * rho_air_zw(k) -                 &
+                                  w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
@@ -3904,6 +3933,7 @@
                       + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k)   -    &
                           swap_diss_y_local(k)              ) * ddy           &
-                      + ( flux_t(k) + diss_t(k) - flux_d - diss_d             &
-                                                               ) * ddzw(k)    &
+                      + ( ( flux_t(k) + diss_t(k) ) -                         &
+                          ( flux_d    + diss_d    )                           &
+                                                    ) * drho_air(k) * ddzw(k) &
                                             ) + sk(k,j,i) * div
 
@@ -4004,5 +4034,5 @@
 
        USE arrays_3d,                                                         &
-           ONLY:  ddzw, tend, u, v, w
+           ONLY:  ddzw, drho_air, tend, u, v, w, rho_air, rho_air_zw
 
        USE constants,                                                         &
@@ -4278,5 +4308,5 @@
                 k_mm  = k - 2 * ibit8
 
-                flux_t    = w(k,j,i) * (                                      &
+                flux_t    = w(k,j,i) * rho_air_zw(k) * (                      &
                            ( 37.0_wp * ibit8 * adv_sca_5                      &
                         +     7.0_wp * ibit7 * adv_sca_3                      &
@@ -4292,5 +4322,5 @@
                                        )
 
-                diss_t    = -ABS( w(k,j,i) ) * (                              &
+                diss_t    = -ABS( w(k,j,i) ) * rho_air_zw(k) * (              &
                            ( 10.0_wp * ibit8 * adv_sca_5                      &
                         +     3.0_wp * ibit7 * adv_sca_3                      &
